unit Main;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics,
  Controls, Forms, Dialogs, StdCtrls, ExtCtrls, Mask,registry;

const
Clas:PChar = 'Windo_w';

type
TStateDial = (Disconnected,Connected,Dialing,Erro_r);
TExecuteDial = (NUL_L,Connect,Disconnect,Status,Data);

type
  TForm1 = class(TForm)
    Button1: TButton;
    ListBox1: TListBox;
    Button2: TButton;
    Button3: TButton;
    Button4: TButton;
    Button5: TButton;
    Button6: TButton;
    Label1: TLabel;
    Label2: TLabel;
    Label3: TLabel;
    Label4: TLabel;
    Label5: TLabel;
    ListBox2: TListBox;
    ListBox3: TListBox;
    Edit1: TEdit;
    MaskEdit1: TMaskEdit;
    Label6: TLabel;
    Label7: TLabel;
    CheckBox1: TCheckBox;
    procedure Button1Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure Button3Click(Sender: TObject);
    procedure Button4Click(Sender: TObject);
    procedure Button5Click(Sender: TObject);
    procedure Button6Click(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure FormCloseQuery(Sender: TObject; var CanClose: Boolean);
    procedure CheckBox1MouseUp(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
  private
  public
    procedure Integrate(Boo_l:boolean);
    function  GetEntry(var ListEntry:TStringList):boolean;
  protected
    procedure WndProc(var Msg:TMessage); override;
  end;


var
  Form1: TForm1;
  hRasConn:integer;
  ST_R:string;
  Messag_e:cardinal;
  Me_s:integer;
  StateDial:TStateDial;
  ExecuteDial:TExecuteDial;
  EntryName:string;
  Execute:boolean;

implementation

uses RASAPI;

{$R *.DFM}

procedure TForm1.WndProc(var Msg:TMessage);
var
COPYDATASTRUC_T:tCOPYDATASTRUCT;
begin
if (Msg.Msg = WM_DESTROY) then
     PostMessage(FindWindow(Clas,Nil),WM_USER,
                              Integer(TStateDial(Erro_r)),0);

if (Msg.Msg = WM_COPYDATA) then begin
      with COPYDATASTRUC_T do begin
         dwData:=0;
         cbData:=0;
         lpData:=Nil;
      end;
      COPYDATASTRUC_T:=tCOPYDATASTRUCT(Pointer(Msg.LParam)^);
      EntryName:=string(PChar(COPYDATASTRUC_T.lpData));
end;

if (Msg.Msg = WM_USER) then begin

    if (TExecuteDial(Msg.WParam) = Status)then
          SendMessage(FindWindow(Clas,Nil),
               WM_USER,Integer(TStateDial(StateDial)),0);

    if (TExecuteDial(Msg.WParam) = Disconnect)then begin
              Button6Click(NIL);
              ExecuteDial:=NUL_L;
              end;

    if (TExecuteDial(Msg.WParam) = Connect)then begin
              Execute:=true;
              Button5Click(Nil);
              Execute:=false;
              end;
end;

inherited WndProc(Msg);
end;

procedure RASCallback(msg: Integer;state:TRasConnState;
                                                wError:Longint); stdcall;
begin
{
Form1.label3.Caption:=StatusStrin_g(State);
Form1.label4.Caption:=inttostr(wError);

form1.ListBox2.Items.Add(inttostr(State));
form1.ListBox3.Items.Add(StatusStrin_g(State));
}
end;

function MessageStatus(P:Pointer):Longint; stdcall
label M1;
var
tRASCONNSTATU_S:tRASCONNSTATUS;
Msg,Msg1:TMessage;
begin
tRASCONNSTATU_S.dwSize:= Sizeof(tRASCONNSTATUS);
M1:
if (RasGetConnectStatus(hRasConn,tRASCONNSTATU_S)=0)then
    begin
    Msg.WParam:=tRASCONNSTATU_S.rasconnstate;
    Msg.LParam:=tRASCONNSTATU_S.dwError;
     if (Msg.WParam <> Msg1.WParam)or(Msg.LParam <> Msg1.LParam)then
      begin
      if (tRASCONNSTATU_S.rasconnstate = RASCS_Connected)then
                                              StateDial:=Connected;

      if (tRASCONNSTATU_S.rasconnstate = RASCS_Disconnected)then
                                              StateDial:=Disconnected;

      if ((tRASCONNSTATU_S.rasconnstate > 0)and
          (tRASCONNSTATU_S.rasconnstate <> RASCS_Connected))then
                                              StateDial:=Dialing;

      SendMessage(FindWindow(Clas,Nil),
                          WM_USER,Integer(TStateDial(StateDial)),0);

      Msg1:=Msg;
      Form1.label3.Caption:=StatusStrin_g(tRASCONNSTATU_S.rasconnstate);
      Form1.label4.Caption:=inttostr(tRASCONNSTATU_S.dwError);

      form1.ListBox2.Items.Add(inttostr(tRASCONNSTATU_S.dwError));
      form1.ListBox3.Items.Add(StatusStrin_g(tRASCONNSTATU_S.rasconnstate));
     end;
    end;
sleep(50);
goto M1;
end;

procedure TForm1.Button1Click(Sender: TObject);
var
Ret,cbBuf,Entry:integer;
tRASENTRYNAM_E:array[0..100] of tRASENTRYNAME;
I:integer;
begin
tRASENTRYNAM_E[0].dwSize:=Sizeof(tRASENTRYNAME);
Entry:=0;
cbBuf:=Sizeof(tRASENTRYNAME)*100;
Ret:=RasEnumEntries(Nil,Nil,@tRASENTRYNAM_E,cbBuf,Entry);

if Ret = 0 then
     begin
     ListBox1.Clear;
     for I:=0 to Entry - 1 do begin
              ListBox1.Items.Add(tRASENTRYNAM_E[I].szEntryName);
              tRASENTRYNAM_E[I].szEntryName:='';
              end;
     end
else
     begin
     beep;
     showmessage(GetErrorString(Ret));
     end;

end;

procedure TForm1.Button2Click(Sender: TObject);
var
Ret,I:DWORD;
begin
Ret:=RasCreatePhonebookEntry(form1.Handle,Nil);

if Ret = ERROR_CANNOT_OPEN_PHONEBOOK then
              showmessage('   ')
else
  begin
  I:=ListBox1.Items.Count;
Button1Click(Nil);
if (Abs(I) = Abs(ListBox1.Items.Count - 1)) then begin
           ListBox1.ItemIndex:=ListBox1.Items.Count - 1;
           Button3Click(nil);
           Integrate(CheckBox1.Checked);
           end;
  end;
end;

procedure TForm1.Button3Click(Sender: TObject);
var
Ret:DWORD;
S:string;
begin
if ListBox1.ItemIndex = -1 then begin
beep;
showmessage('   ');
exit;
end;

Ret:=RasEditPhonebookEntry(form1.Handle,Nil,
           PChar(ListBox1.Items.Strings[ListBox1.ItemIndex]));

if Ret <> 0 then begin
   if Ret = ERROR_BUFFER_INVALID then
       S:='    .';
   if Ret = ERROR_CANNOT_OPEN_PHONEBOOK then
       S:='     .';
   if Ret = ERROR_CANNOT_FIND_PHONEBOOK_ENTRY then
       S:='    ';

beep;
showmessage(' ' + S);
end;

end;

procedure TForm1.Button4Click(Sender: TObject);
var
Ret:DWORD;
begin
if ListBox1.ItemIndex = -1 then begin
beep;
showmessage('   ');
exit;
end;

Ret:=RasDeleteEntry(Nil,
          PChar(ListBox1.Items.Strings[ListBox1.ItemIndex]));

if Ret = ERROR_INVALID_NAME then begin
beep;
showmessage(' ');
                    end
else
Button1Click(Nil);
end;

procedure TForm1.Button5Click(Sender: TObject);
label
M1;
var
rdParams:tRASDIALPARAMS;
Ret:integer;
S:string;
begin

if Execute then goto M1;

if (ListBox1.ItemIndex = -1) then begin
beep;
showmessage('   ');
exit;
end;

ListBox2.Clear;
ListBox3.Clear;

if (hRasConn <> 0) then
   begin
   RasHangUpA(hRasConn);
   hRasConn:=0;
   exit;
   end;

S:=ListBox1.Items.Strings[ListBox1.ItemIndex];

StringToArray(S,rdParams.szEntryName);

M1:
if Execute then
            StringToArray(EntryName,rdParams.szEntryName);

label1.Caption:=EntryName;

rdParams.szPhoneNumber:='';
rdParams.szCallbackNumber:='';

if (Trim(Edit1.Text) <> '') then
   StringToArray(Edit1.Text,rdParams.szUserName)
else
   rdParams.szUserName:='';

if (Trim(MaskEdit1.Text) <> '') then
   StringToArray(MaskEdit1.Text,rdParams.szPassword)
else
   rdParams.szPassword:='';

rdParams.szDomain:='*';
rdParams.dwSize := sizeof(tRASDIALPARAMS);

hRasConn := 0;

Ret:=RasDial(Nil,Nil,rdParams,0,@RASCallback,hRasConn);

if Ret <> 0 then
       begin
       beep;
       showmessage(GetErrorString(Ret)+' ***' + EntryName);
       exit;
       end;


end;

procedure TForm1.Button6Click(Sender: TObject);
begin
RasHangUp(hRasConn);
ListBox2.Clear;
ListBox3.Clear;
end;

procedure TForm1.FormCreate(Sender: TObject);
var
Thread:Thandle;
Registry:TRegistry;
Path:string;
begin
Path:=Application.ExeName;
Registry:=TRegistry.Create;
Registry.RootKey:=HKEY_CURRENT_USER;
Registry.OpenKey('SOFTWARE\VDialer\Config',true);
Registry.WriteString('PATHEXE',Path);

if (Registry.ValueExists('Integrate'))then
    CheckBox1.Checked:=Registry.ReadBool('Integrate')
else
Registry.WriteBool('Integrate',false);

Registry.CloseKey;
Registry.Free;

Integrate(CheckBox1.Checked);

CreateThread(Nil,0,@MessageStatus,Nil,0,Thread);

Button1Click(Nil);
label1.Caption:='';
label2.Caption:='';
label3.Caption:='';
label4.Caption:='';
label5.Caption:='';

StateDial:=Disconnected;
end;

procedure TForm1.FormCloseQuery(Sender: TObject; var CanClose: Boolean);
begin
RasHangUp(hRasConn);
end;

procedure TForm1.CheckBox1MouseUp(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
var
Registry:TRegistry;
begin
Registry:=TRegistry.Create;
Registry.RootKey:=HKEY_CURRENT_USER;
Registry.OpenKey('SOFTWARE\VDialer\Config',true);
Registry.WriteBool('Integrate',CheckBox1.Checked);
Registry.CloseKey;
Registry.Free;

Integrate(CheckBox1.Checked);
end;

procedure TForm1.Integrate(Boo_l:boolean);
var
ST:TStringList;
I,Coun_t:integer;
S,S1:string;
P:Pointer;
Size1,Size2:integer;
tRASENTR_Y:tRASENTRY;
AutodialDll,AutodialFunc:array [0..MAX_PATH - 1] of AnsiChar;

  procedure Se_t(I:integer);
  begin
    Size2:=0;
    S1:=ST.Strings[I];
    RasGetEntryPropertiesA(Nil,Pchar(S1),@tRASENTR_Y,Size1,Nil,Size2);
    Getmem(P,Size2);
    RasGetEntryPropertiesA(Nil,Pchar(S1),@tRASENTR_Y,Size1,P,Size2);

    if (Boo_l)then
       begin
       ArrayToArray(AutodialDll,tRASENTR_Y.szAutodialDll);
       ArrayToArray(AutodialFunc,tRASENTR_Y.szAutodialFunc);
       RasSetEntryPropertiesA(Nil,Pchar(S1),@tRASENTR_Y,Sizeof(tRASENTR_Y),P,Size2);
       end
    else
       begin
       tRASENTR_Y.szAutodialDll:='';
       tRASENTR_Y.szAutodialFunc:='';
       RasSetEntryPropertiesA(Nil,Pchar(S1),@tRASENTR_Y,Sizeof(tRASENTR_Y),P,Size2);
       end;
    FreeMem(P,Size2);
  end;

begin
tRASENTR_Y.dwSize:=Sizeof(tRASENTRY);

S:=ExtractFileDir(Application.ExeName) + '\VDialerD.dll';
StringToArray(S,AutodialDll);
StringToArray('VDialer',AutodialFunc);

ST:=TStringList.Create;

if (GetEntry(ST))then begin
   Coun_t:=ST.Count - 1;
   Size1:=Sizeof(tRASENTR_Y);

   for I:=0 to Coun_t do Se_t(I);
   end;

ST.Free;
end;

function TForm1.GetEntry(var ListEntry:TStringList):boolean;
var
Ret,cbBuf,Entry:integer;
tRASENTRYNAM_E:array[0..100] of tRASENTRYNAME;
I:integer;
begin
tRASENTRYNAM_E[0].dwSize:=Sizeof(tRASENTRYNAME);
Entry:=0;
cbBuf:=Sizeof(tRASENTRYNAME)*100;
Ret:=RasEnumEntriesA(Nil,Nil,@tRASENTRYNAM_E,cbBuf,Entry);

if Ret = 0 then
     begin
     ListEntry.Clear;
     for I:=0 to Entry - 1 do begin
              ListEntry.Add(tRASENTRYNAM_E[I].szEntryName);
              tRASENTRYNAM_E[I].szEntryName:='';
              end;
     Result:=true;
     end
else
     Result:=false;
end;

end.


