library VDialerD;


uses
  windows,
  SysUtils,
  messages;

const
Clas:PChar  = 'TForm1';
Title:PChar = '  ';
WindowClas_s:PChar ='Windo_w';

type
TStateDial = (Disconnected,Connected,Dialing,Erro_r);
TExecuteDial = (NUL_L,Connect,Disconnect,Status,Data);

type tagRASADPARAMS =record
       dwSize:DWORD;
       hwndOwner:HWND;
       dwFlags:DWORD;
       xDlg:Longint;
       yDlg:Longint;
end;
RASADPARAMS = tagRASADPARAMS;
LPRASADPARAMS = ^RASADPARAMS;

var
HWindow:HWND;
Thread:DWORD;
StateDial:TStateDial;
Hi:Longint;

function SetWindow(P:Pointer):Longint; stdcall;
var
AMessage:TMsg;

         function WindowProc(Window:HWND;
               AMessage,WParam,LParam:Longint):Longint;stdcall;export;
         begin
              WindowProc:=0;
              case AMessage of
              WM_DESTROY:begin
                         PostQuitMessage(0);
                         exit;
                         end;
              end;

              if (AMessage = WM_USER)then
                                 StateDial:=TStateDial(WParam);

         WindowProc:=DefWindowProc(Window,AMessage,WParam,LParam);
         end;

         function WinCreate:HWND;
         var
         WindowClass:TWndClass;
         HWindow:HWND;
         begin
         Hi:=FindHInstance(@SetWindow);

         with WindowClass do begin
              style:= CS_GLOBALCLASS;
              lpfnWndProc:= @WindowProc;
              cbClsExtra:=0;
              cbWndExtra:=0;
              hInstance:=Hi;
              hIcon:=0;
              hCursor:=0;
              hbrBackground:=0;
              lpszMenuName:=Nil;
              lpszClassName:=WindowClas_s;
              end;

         RegisterClass(WindowClass);
         HWindow:=CreateWindow(WindowClas_s,Nil,0,0,0,0,0,0,0,Hi,Nil);
         Result:=HWindow;
         end;

begin
HWindow:=WinCreate;

   if (HWindow = 0) then begin
         Result:=1;
         exit;
   end;

   while GetMessage(AMessage,0,0,0) do begin
         TranslateMessage(AMessage);
         DispatchMessage(AMessage);
   end;
Result:=0;
end;

function Create_Process:boolean;
var
TempKey:HKEY;
Path:array[0..255] of char;
Size:PDWORD;
fCuccess:boolean;
STARTUPINF_O:tSTARTUPINFO;
PROCESS_INFORMATIO_N:TProcessInformation;
begin
GetMem(Size,Sizeof(Size));
Size^:=255;
if (RegOpenKeyEx(HKEY_CURRENT_USER,'SOFTWARE\VDialer\Config',
                     0,KEY_READ,TempKey) = 0)then begin
   if (RegQueryValueEx(TempKey,PChar('PATHEXE'),
                           Nil,Nil,@Path,Size)<> 0)then begin
       RegCloseKey(TempKey);
       Result:=false;
       exit;
       end;
    end
else
    begin
    RegCloseKey(TempKey);
    Result:=false;
    exit;
    end;

RegCloseKey(TempKey);

GetStartupInfo(STARTUPINF_O);
STARTUPINF_O.wShowWindow:=SW_NORMAL;

fCuccess:=CreateProcess(Path,nil,
     Nil,Nil,true,NORMAL_PRIORITY_CLASS,Nil,Nil,
                               STARTUPINF_O,PROCESS_INFORMATIO_N);

if (fCuccess) then begin
   CloseHandle(PROCESS_INFORMATIO_N.hThread);
   CloseHandle(PROCESS_INFORMATIO_N.hProcess);
   Result:=true;
   end
else
   Result:=false;
end;

procedure DllMain(fdwReason:DWORD);
begin
case fdwReason of
//     DLL
DLL_PROCESS_DETACH:SendMessage(HWindow,WM_DESTROY,0,0);
end;
end;


//  *********************************************
function VDialer(lpszPhonebook:Pchar;lpszEntry:Pchar;
 lpAutodialParams:LPRASADPARAMS;var lpdwRetCode:LPDWORD):Boolean; stdcall; export;
label
Error;
var
Ret:DWORD;
I:integer;
Hw1,Hw2,Hw3:HWND;
COPYDATASTRUC_T:tCOPYDATASTRUCT;
begin
//    
Hw1:=GetActiveWindow;
Hw2:=GetWindow(Hw1,GW_OWNER);

//  
if (HWindow = 0) then
                  CreateThread(Nil,0,@SetWindow,Nil,0,Thread);

//     - 
if (FindWindow(Clas,Title) = 0)then begin
             if (Not Create_Process) then goto Error;
             end;

sleep(500);
Hw3:=FindWindow(Clas,Title);

//  
SendMessage(Hw3,WM_USER,Integer(TExecuteDial(Status)),0);

if (StateDial = Dialing)then
         SendMessage(Hw3,WM_USER,Integer(TExecuteDial(Disconnect)),0);

for i:=1 to 5 do begin
   if (StateDial = Disconnected)then break;
   Sleep(500);
end;

//  
with COPYDATASTRUC_T do begin
     dwData:=Cardinal(TExecuteDial(Data));
     cbData:=StrLen(lpszEntry)*Sizeof(char);
     lpData:=lpszEntry;
     end;

SendMessage(FindWindow(Clas,Title),WM_COPYDATA,
                              HWindow,Integer(@COPYDATASTRUC_T));

//
SendMessage(Hw3,WM_USER,Integer(TExecuteDial(Connect)),0);

//      
while (StateDial <> Connected)do begin
 if (StateDial = Erro_r)then goto Error;
 if (Hw1 <> 0) then
                UpdateWindow(Hw1);
 if (Hw2 <> 0) then
                UpdateWindow(Hw2);
 sleep(100);
 end;

//  
Ret:=0;
GetMem(lpdwRetCode,Sizeof(Ret));
lpdwRetCode^:=Ret;
StateDial:=Disconnected;
Result:=true;
exit;

//
Error:
   Ret:=1;
   GetMem(lpdwRetCode,Sizeof(Ret));
   lpdwRetCode^:=Ret;
   StateDial:=Disconnected;
   Result:=false;
end;

exports
VDialer index 1 name 'VDialer';

begin
DllProc:=@DllMain;
end.

